% Calculate FEVD
function fevds = fevd_func(F,B,P,D,Sigma,nhvars_fevd,hvars_fevd,K)

% Dimensions: Shock, Variable, Horizon
fevds = NaN(K,K,nhvars_fevd);

for ishock = 1:K
        for ihvar = 1:nhvars_fevd
            hvar_fevd = hvars_fevd(ihvar);
            for ivar = 1:K
                top = 0;
                bottom = 0;
                for j=0:hvar_fevd
                    Bvar = B(ivar,K*j+1:K*j+K);
                    top = top + (Bvar*P*D(:,ishock))*((P*D(:,ishock))'*Bvar');
                    bottom = bottom + Bvar*Sigma*Bvar';
                end
                fevds(ishock,ivar,ihvar) = top/bottom;
            end
        end
end
end