function [T,M,eu] = linmodel(P,S,V)

%---------------------------------------------
%   Initialize GENSYS components
%---------------------------------------------
G0 = zeros(V.nvar);
G1 = zeros(V.nvar);
Psi = zeros(V.nvar,V.nshock);
Pi = zeros(V.nvar,V.nfore);
CC = zeros(V.nvar,1);
j = 0;
%---------------------------------------------
j=j+1;  %[Production Function]
%---------------------------------------------
G0(j,V.y) = 1;
G0(j,V.k) = -P.alpha;
G0(j,V.n) = -(1-P.alpha);
%---------------------------------------------
j=j+1;  %[Firm FOC Capital]
%---------------------------------------------
G0(j,V.rk) = 1;
G0(j,V.y) = -1;
G0(j,V.k) = 1;
%---------------------------------------------
j=j+1;  %[Firm FOC Labor]
%---------------------------------------------
G0(j,V.w) = 1;
G0(j,V.y) = -1;
G0(j,V.n) = 1;
%---------------------------------------------
j=j+1;  %[HH FOC Labor]
%---------------------------------------------
G0(j,V.w) = 1;
G0(j,V.c) = -1;
G0(j,V.n) = -P.n/(1-P.n);
%---------------------------------------------
j=j+1;  %[ARC]
%---------------------------------------------
G0(j,V.c) = S.c;
G0(j,V.i) = S.i;
G0(j,V.y) = -S.y;
%---------------------------------------------
j=j+1;  %[Value Function]
%---------------------------------------------
G0(j,V.J) = 1;
G0(j,V.u) = -(1-P.beta);
G0(j,V.z) = -P.beta;
%---------------------------------------------
j=j+1;  %[Pricing Kernel]
%---------------------------------------------
G0(j,V.x) = 1;
G0(j,V.c) = 1;
G0(j,V.J) = -(1/P.psi-P.gamma);
G0(j,V.u) = -(1-1/P.psi);
G1(j,V.c) = 1;
G1(j,V.z) = -(1/P.psi-P.gamma);
G1(j,V.u) = -(1-1/P.psi);
%---------------------------------------------
j=j+1;  %[Capital LOM]
%---------------------------------------------
G0(j,V.k) = 1;
G1(j,V.k) = 1-P.delta;
G1(j,V.i) = P.delta;
%---------------------------------------------
j=j+1;  %[Utility]
%---------------------------------------------
G0(j,V.u) = 1;
G0(j,V.c) = -S.eta;
G0(j,V.n) = (1-S.eta)*P.n/(1-P.n);
%---------------------------------------------
j=j+1;  %[Risk Aggregator]
%---------------------------------------------
G0(j,V.eJ) = 1;
G0(j,V.z) = -1;
%---------------------------------------------
j=j+1;  %[HH FOC Capital]
%---------------------------------------------
G0(j,V.ex) = 1;
G0(j,V.erk) = P.beta*S.rk;
%---------------------------------------------
j=j+1;  %[Disaster Risk Process]
%---------------------------------------------
G0(j,V.e) = 1;
G1(j,V.e) = P.rhoe;
Psi(j,V.epse) = P.sige;
%---------------------------------------------
j=j+1;  %[Technology Process]
%---------------------------------------------
G0(j,V.a) = 1;
G1(j,V.a) = P.rhoa;
Psi(j,V.epsa) = P.siga;

%---------------------------------------------
j=j+1;  %[FE Pricing Kernel]
%---------------------------------------------
G0(j,V.x) = 1;
G1(j,V.ex) = 1;
Pi(j,V.fex) = 1;
%---------------------------------------------
j=j+1;  %   [FE Rental Rate]
%---------------------------------------------
G0(j,V.rk) = 1;
G1(j,V.erk) = 1;
Pi(j,V.ferk) = 1;
%---------------------------------------------
j=j+1;  %[FE Value Function]
%---------------------------------------------
G0(j,V.J) = 1;
G1(j,V.eJ) = 1;
Pi(j,V.feJ) = 1;

%---------------------------------------------
%   Solve Linear Model
%---------------------------------------------
[T,~,M,~,~,~,~,eu] = gensys(G0,G1,CC,Psi,Pi);