function P = parameters(O)

% Deep parameters
P.gamma     = 80;              % Risk aversion 
P.psi       = 1;               % IES 
P.alpha     = 0.3333;          % Cost share of capital
P.beta      = 0.995;           % Discount factor 
P.delta     = 0.025;           % Capital depreciation rate 
P.theta     = 0.95;            % Capital quality

% Process parameters
P.rhoe      = 0.9;             % Disaster risk persistence
P.rhoa      = 0.9;             % Technology persistence
P.siga      = 0.008;           % Technology shock SD
P.rhosv     = 0.9;             % Technology volatility shock persistence

if strcmp(O.mod,'base')   
    P.sige      = 0.0065;      % Disaster risk shock SD
    P.sigsv     = 0.0275;      % Technology volatility shock SD       
elseif strcmp(O.mod,'qr')
    P.sige      = 0.0065;      % Disaster risk shock SD
    P.sigsv     = 0.080;       % Technology volatility shock SD  
end

% Normalizations
P.estar     = 0.97;            % Capital quality threshold
P.e         = 1;               % Disaster risk mean
P.a         = 1;               % Technology
P.n         = 1/3;             % Hours
