%Simulate DSGE model 
clear; clc;
saving = 1;

% Solution options
mod = 'qr';
fname = ['mats/Msolution-dens-' mod '.mat'];

% Simulation options
F.nreps = 1;
F.ndata= 1e6;
F.nburn = 1e4;

% Set random number seed and draw shocks
mtstream = RandStream('mt19937ar','seed',123456);
RandStream.setGlobalStream(mtstream);

% Load solution
load(fname);
V = variables;

% Draw shocks
shockslong = randn(F.nburn+F.ndata,V.nshock+1,F.nreps);

% Short-sample simulations
disp('Simulating...');
sims = simulation(pf,P,S,G,V,permute(shockslong,[1,3,2])); 
sims = sims(F.nburn+1:end,:,:);

% Save
if saving==1 
    matname = ['mats/simdata-' O.mod '.mat'];             
    save(matname,'sims','F','shockslong');
end