function M = momcalc(V,F,sims)

% Sample indexes
T = F.nlagQ+1:F.ndataQ-1;
Tnof = F.nlagQ+1:F.ndataQ;

sd_yfs = zeros(1,F.nreps);
sd_afs = zeros(1,F.nreps);
sd_ygs = zeros(1,F.nreps);
sd_uys = zeros(1,F.nreps);
sd_Uys = zeros(1,F.nreps);
ac_yfs = zeros(1,F.nreps);
ac_afs = zeros(1,F.nreps);
corr_yfuys = zeros(1,F.nreps);
corr_yguys = zeros(1,F.nreps);
for irep = 1:F.nreps
    % Assign variable
    simy = sims(:,V.y,irep);
    sima = sims(:,V.a,irep);  
    simuy = sims(:,V.uy,irep);    

    % Transform data
    %   Detrended
    simyf = 100*(log(simy(2:end)) - log(mean(simy(Tnof))));
    simaf = 100*(sima(2:end) - mean(sima(Tnof)));
    simyg = 100*diff(log(simy));
    simuyf = 100*simuy(2:end);
    % SDS
    sd_yfs(irep) = std(simyf(T));
    sd_afs(irep) = std(simaf(T));
    sd_ygs(irep) = std(simyg(T));
    sd_uys(irep) = std(simuyf(T));
    sd_Uys(irep) = 100*std(simuyf(T))/sd_ygs(irep);
    % ACs
    ac_yfs(irep) = corr(simyf(T),simyf(T-1));
    ac_afs(irep) = corr(simaf(T),simaf(T-1));
    % CORRs
    corr_yfuys(irep) = corr(simyf(T),simuyf(T));
    corr_yguys(irep) = corr(simyg(T),simuyf(T));
end
% SDS
M.sd_yf = mean(sd_yfs,'omitnan');
M.sd_af = mean(sd_afs,'omitnan');
M.sd_yg = mean(sd_ygs,'omitnan');
M.sd_uy = mean(sd_uys,'omitnan');
M.sd_Uy = mean(sd_Uys,'omitnan');
% ACs
M.ac_yf = mean(ac_yfs,'omitnan');
M.ac_af = mean(ac_afs,'omitnan');
% CORRs
M.corr_yfuy = mean(corr_yfuys,'omitnan');
M.corr_yguy = mean(corr_yguys,'omitnan');