clear; clc; genresults = 1;

% Options
excel_write = 1;
thirdvarlist = {'i','c','n','w'};  
nthirdvar = size(thirdvarlist,2);

for ivar = 1:nthirdvar
    middlevar = thirdvarlist{ivar};
    disp(['VAR Third Variable ' middlevar])
    % Model 1: epse-epsev-epsa
    %  Baseline calibration
    mod = 'base';
    %   Set variables for Cholesky
    run epse-epsev-epsa/script_var_results
    rmse_chol1_base = rmses';
    %   Set variables for max share 
    varslist = {'uy','y',thirdvarlist{ivar}}; 
    run epse-epsev-epsa/script_var_results_maxshare
    rmse_ms1_base = rmses';
    run epse-epsev-epsa/script_var_results_maxshare_news
    rmse_msnews1_base = rmses';
    rmse1_base = [rmse_chol1_base;rmse_ms1_base;rmse_msnews1_base];
    %  Quasi-Recursive calibration
    mod = 'qr';
    %   Set variables for Cholesky
    run epse-epsev-epsa/script_var_results
    rmse_chol1_qr = rmses';
    %   Set variables for max share 
    varslist = {'uy','y',thirdvarlist{ivar}};
    run epse-epsev-epsa/script_var_results_maxshare
    rmse_ms1_qr = rmses';
    run epse-epsev-epsa/script_var_results_maxshare_news
    rmse_msnews1_qr = rmses';
    rmse1_qr = [rmse_chol1_qr;NaN;rmse_ms1_qr;rmse_msnews1_qr];

    % Model 2: epse-epsav-epsa
    %  Baseline calibration
    mod = 'base';
    %   Set variables for Cholesky
    run epse-epsav-epsa/script_var_results
    rmse_chol2_base = rmses';
    %   Set variables for max share 
    varslist = {'uy','y',thirdvarlist{ivar}};
    run epse-epsav-epsa/script_var_results_maxshare
    rmse_ms2_base = rmses';
    run epse-epsav-epsa/script_var_results_maxshare_news
    rmse_msnews2_base = rmses';
    rmse2_base = [rmse_chol2_base;rmse_ms2_base;rmse_msnews2_base];
    %  Quasi-Recursive calibration
    mod = 'qr';
    %   Set variables for Cholesky
    run epse-epsav-epsa/script_var_results
    rmse_chol2_qr = rmses';
    %   Set variables for max share 
    varslist = {'uy','y',thirdvarlist{ivar}};
    run epse-epsav-epsa/script_var_results_maxshare
    rmse_ms2_qr = rmses';
    run epse-epsav-epsa/script_var_results_maxshare_news
    rmse_msnews2_qr = rmses';
    rmse2_qr = [rmse_chol2_qr;NaN;rmse_ms2_qr;rmse_msnews2_qr];

    % Table
    rmse_out = [rmse1_base,rmse1_qr,rmse2_base,rmse2_qr];
    tab = array2table(rmse_out);
    tab = varfun(@(x) num2str(x, ['%',sprintf('.%df',1)]), tab);
    tab.Properties.RowNames = {'Cholesky: U First', ...
                               'Cholesky: U Last', ...
                               'Max Share', ...
                               'Constrained Max Share', ...
                               'Internal IV'};
    tab.Properties.VariableNames = {'Model 1: Base', ...
                                    'Model 1: QR', ...
                                    'Model 2: Base', ...
                                    'Model 2: QR'};
    disp(tab)

    % Write to Excel
    if excel_write == 1 
        disp('Writing to Excel...')
        writematrix(rmse_out,'tables.xlsx','Sheet',V.desc{V.(middlevar)},'Range','B4','AutoFitWidth',0)
        t = datetime("now");
        writematrix(exceltime(t),'tables.xlsx','Sheet',V.desc{V.(middlevar)},'Range','A11')
    end
end