% Estimates a level VAR with intercept in companion form by OLS

function [A,SIGMA,U,V,Y,X] = lsvarc(y,p)

%t: Number of observations
%q: Number of variables
[t,q] = size(y); 
y = y';
Y = y(:,p:t);
for i =1:p-1
    % Companion matrix
    Y = [Y; y(:,p-i:t-i)]; 
end
X = [ones(1,t-p); Y(:,1:t-p)];
Y = Y(:,2:t-p+1);
A = (Y*X')/(X*X');

% Reduced form residuals
U = Y-A*X;

% Variance-covariance matrix (upper left hand block) 
SIGMA = U*U'/(t-p-p*q-1); 
SIGMA = SIGMA(1:q,1:q);

% Intercept terms
V = A(:,1); 

% Slope coefficients
A = A(:,2:q*p+1); 